/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 1024
#ifdef HAVE_CONFIG_H
#line 1024
# include <config.h>
#line 1024
#endif
#line 1024
#include <sys/types.h>
#line 1024

#line 1024
#include "mailfromd.h"
#line 1024
#include "prog.h"
#line 1024
#include "builtin.h"
#line 1024

#line 179 "io.bi"
static mu_debug_handle_t debug_handle;
#line 1024 "io.bi"

#line 765 "../../src/builtin/snarf.m4"

#line 1 "io.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2006, 2007, 2008, 2009, 2010, 2011 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <mflib/status.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include "global.h"
#include "msg.h"

static size_t nstreams = MAX_IOSTREAMS;

static struct mu_cfg_param io_cfg_param[] = {
	{ "max-streams", mu_cfg_size, &nstreams, 0, NULL,
	  N_("Maximum number of stream descriptors.") },
	{ NULL }
};

struct io_stream {
	char *name;
	mu_locker_t lock;
	int fd[2];
	pid_t pid;
	char *buf;
	size_t bufsize;
	int (*shutdown)(struct io_stream *, int what);
	void (*cleanup)(void*);
	void *cleanup_data;
	char *delim;
};

#define IFD(s) ((s).fd[0])
#define OFD(s) ((s).fd[1] == -1 ? (s).fd[0] : (s).fd[1])

static void
flush_stream(struct io_stream *str)
{
	/*FIXME*/
}

static void
close_stream(struct io_stream *str)
{
	if (OFD(*str) == -1)
		return;
	flush_stream(str);
	close(OFD(*str));
	if (IFD(*str) != -1)
		close(IFD(*str));
	if (str->pid) {
		int status;
		waitpid(str->pid, &status, 0);
	}
	str->fd[0] = -1;
	str->fd[1] = -1;
	str->pid = 0;
	if (str->cleanup)
		str->cleanup(str->cleanup_data);
	str->cleanup = NULL;
	str->cleanup_data = NULL;
	if (str->name) {
		free(str->name);
		str->name = NULL;
	}
	if (str->delim) {
		free(str->delim);
		str->delim = NULL;
	}
}

/* Read bytes from the stream STR into its buffer, until
   DELIM is encountered. Return number of bytes read. */
static int
read_stream_delim(struct io_stream *str, char *delim)
{
	int fd = IFD(*str);
	size_t i = 0;
	int rc;
	size_t delim_len = strlen(delim);
	
	for (;;) {
		if (str->bufsize == i) {
			if (str->bufsize == 0) 
				str->bufsize = 16;
			str->buf = x2nrealloc(str->buf, &str->bufsize,
					      sizeof str->buf[1]);
		}
		rc = read(fd, str->buf + i, 1);
		if (rc == -1)
			return -1;
		else if (rc == 0)
			return 0;
		i++;
		if (i >= delim_len &&
		    memcmp(str->buf + i - delim_len, delim, delim_len) == 0) {
			str->buf[i - delim_len] = 0;
			break;
		}
	}
	return i;
}

#define REDIRECT_STDIN_P(f) ((f) & (O_WRONLY|O_RDWR))
#define REDIRECT_STDOUT_P(f) ((f) & (O_RDONLY|O_RDWR))

#define STDERR_SHUT        0
#define STDERR_NULL        1
#define STDERR_LOG         2
#define STDERR_FILE        3
#define STDERR_FILE_APPEND 4

#define LOG_TAG_PFX "mailfromd:"
#define LOG_TAG_PFX_LEN (sizeof(LOG_TAG_PFX)-1)

static void
stderr_to_log(char *arg, const char *cmd)
{
	int p[2];
	pid_t pid;
	
	if (pipe(p)) {
		mu_error(_("pipe failed: %s"), mu_strerror(errno));
		close(2);
		return;
	}

	pid = fork();

	if (pid == (pid_t) -1) {
		mu_error(_("fork failed: %s"), mu_strerror(errno));
		close(p[0]);
		close(p[1]);
		close(2);
		return;
	}
	
	/* Child */
	if (pid == 0) {
		FILE *fp;
		fd_set fdset;
		size_t len;
		char *buf = NULL;
		size_t bufsize = 0;
		char *tag;
		int fac = mu_log_facility, pri = LOG_ERR;
		
		if (arg) {
			char *p = strchr(arg, '.');

			if (p)
				*p++ = 0;
			if (mu_string_to_syslog_facility(arg, &fac)) {
				mu_error(_("unknown syslog facility (%s), "
					   "redirecting stderr to %s"),
					 arg,
					 mu_syslog_facility_to_string(fac));
			}
			
			if (p && mu_string_to_syslog_priority(p, &pri)) {
				mu_error(_("unknown syslog priority (%s), "
					   "redirecting stderr to %s"),
					 arg,
					 mu_syslog_priority_to_string(pri));
			}
		}
		
#line 179 "io.bi"

#line 179
mu_debug(debug_handle, 10,("redirecting stderr to syslog %s.%s",
		           mu_syslog_facility_to_string(fac),
		           mu_syslog_priority_to_string(pri)));
#line 183
		
		len = strcspn(cmd, " \t");
		tag = malloc(LOG_TAG_PFX_LEN + len + 1);
		if (!tag)
			tag = (char*) cmd;
		else {
			strcpy(tag, LOG_TAG_PFX);
			memcpy(tag + LOG_TAG_PFX_LEN, cmd, len);
			tag[LOG_TAG_PFX_LEN + len] = 0;
		}
		mf_proctitle_format("%s redirector", cmd);

		FD_ZERO(&fdset);
		FD_SET(p[0], &fdset);
		logger_fdset(&fdset);
		close_fds_except(&fdset);

		fp = fdopen(p[0], "r");
		logger_open();
		while (getline(&buf, &bufsize, fp) > 0)
			syslog(pri, "%s", buf);
		exit(0);
	}

	/* Parent */
	close(p[0]);
	dup2(p[1], 2);
	close(p[1]);
}
	
static void
stderr_handler(int mode, char *arg, const char *cmd)
{
	int fd;
	int append = O_TRUNC;
	
	switch (mode) {
	case STDERR_SHUT:
		close(2);
		break;

	case STDERR_NULL:
		arg = "/dev/null";
	case STDERR_FILE_APPEND:
		append = O_APPEND;
	case STDERR_FILE:
		if (!arg || !*arg) {
			close(2);
			break;
		}
		
#line 233

#line 233
mu_debug(debug_handle, 10,("redirecting stderr to %s", arg));
		fd = open(arg, O_CREAT|O_WRONLY|append, 0644);
		if (fd < 0) {
			mu_error(_("cannot open file %s for appending: %s"),
				 arg, mu_strerror(errno));
			close(2);
			return;
		}
		if (fd != 2) {
			dup2(fd, 2);
			close(fd);
		}
		break;

	case STDERR_LOG:
		stderr_to_log(arg, cmd);
	}
}

static void
parse_stderr_redirect(const char **pcmd, int *perr, char **parg)
{
	int err;
	size_t len;
	char *arg;
	const char *cmdline = *pcmd;
	
	while (*cmdline && c_isspace(*cmdline))
		cmdline++;
	if (strncmp(cmdline, "2>file:", 7) == 0) {
		cmdline += 7;
		err = STDERR_FILE;
	} else if (strncmp(cmdline, "2>>file:", 8) == 0) {
		cmdline += 8;
		err = STDERR_FILE_APPEND;
	} else if (strncmp(cmdline, "2>null:", 7) == 0) {
		cmdline += 7;
		err = STDERR_NULL;
	} else if (strncmp(cmdline, "2>syslog:", 9) == 0) {
		cmdline += 9;
		err = STDERR_LOG;
	} else
		return;

	len = strcspn(cmdline, " \t");
	if (len > 0 && cmdline[len-1] == 0)
		return;
	if (len == 0)
		arg = NULL;
	else {
		arg = malloc(len + 1);
		if (!arg)
			return;
		memcpy(arg, cmdline, len);
		arg[len] = 0;
	}

	*pcmd = cmdline + len;
	*perr = err;
	*parg = arg;
}


static int
open_program_stream(eval_environ_t env,
		    struct io_stream *str, const char *cmdline,
		    int flags)
{
	int rightp[2], leftp[2];
	int rc = 0;
	pid_t pid;
	int err = STDERR_SHUT;
	char *arg = NULL;
	struct mu_wordsplit ws;
	
	parse_stderr_redirect(&cmdline, &err, &arg);
	while (*cmdline && (*cmdline == ' ' || *cmdline == '\t'))
		cmdline++;
	
	if (REDIRECT_STDIN_P(flags))
		pipe(leftp);
	if (REDIRECT_STDOUT_P(flags))
		pipe(rightp);

	switch (pid = fork()) {
		/* The child branch.  */
	case 0:
		/* attach the pipes */

		/* Right-end */
		if (REDIRECT_STDOUT_P(flags)) {
			if (rightp[1] != 1) {
				close(1);
				dup2(rightp[1], 1);
			}
			close(rightp[0]);
		}

		/* Left-end */
		if (REDIRECT_STDIN_P(flags)) {
			if (leftp[0] != 0) {
				close(0);
				dup2(leftp[0], 0);
			}
			close(leftp[1]);
		}
      
		stderr_handler(err, arg, cmdline);
		
		/* Close unneded descripitors */
		close_fds_above(2);

		
#line 345

#line 345
mu_debug(debug_handle, 10,("running %s", cmdline));
		if (mu_wordsplit(cmdline, &ws, MU_WRDSF_DEFFLAGS)) {
			mu_error(_("cannot parse command line %s: %s"),
				 cmdline, mu_wordsplit_strerror(&ws));
			exit(127);
		}
		execvp(ws.ws_wordv[0], ws.ws_wordv);
		mu_error(_("cannot run %s: %s"),
			 cmdline, mu_strerror(errno));
		exit(127);
		/********************/

		/* Parent branches: */
	case -1:
		/* Fork has failed */
		/* Restore things */
		rc = errno;
		if (REDIRECT_STDOUT_P(flags)) {
			close(rightp[0]);
			close(rightp[1]);
		}
		if (REDIRECT_STDIN_P(flags)) {
			close(leftp[0]);
			close(leftp[1]);
		}
		break;
		
	default:
		str->pid = pid;
		if (REDIRECT_STDOUT_P(flags)) {
			str->fd[0] = rightp[0];
			close(rightp[1]);
		} else
			str->fd[0] = -1;

		if (REDIRECT_STDIN_P(flags)) {
			str->fd[1] = leftp[1];
			close(leftp[0]);
		} else
			str->fd[1] = -1;
	}
	free(arg);
	return rc;
}


static int
open_file_stream(eval_environ_t env,
		 struct io_stream *str, const char *file, int flags)
{
	str->fd[0] = open(file, flags, 0644); /* FIXME: mode? */
	if (str->fd[0] == -1)
		return errno;
	return 0;
}



static int
open_parsed_inet_stream(eval_environ_t env,
			struct io_stream *str,
			const char *cstr,
			char *proto, char *port, char *path,
			int flags)
{
	union {
		struct sockaddr sa;
		struct sockaddr_in s_in;
		struct sockaddr_un s_un;
#ifdef GACOPYZ_IPV6
		struct sockaddr_in6 s_in6;
#endif
	} addr;

	socklen_t socklen;
	int fd;
	int rc;

	if (!proto
	    || strcmp(proto, "unix") == 0 || strcmp(proto, "local") == 0) {
		struct stat st;
		
			if (!(port == NULL))
#line 427
		(
#line 427
	env_throw_bi(env, mfe_failure, NULL, _("invalid connection type: %s; "
			    "port is meaningless for UNIX sockets"),cstr)
#line 427
)
#line 431
;
		
			if (!(strlen(path) <= sizeof addr.s_un.sun_path))
#line 433
		(
#line 433
	env_throw_bi(env, mfe_range, NULL, _("%s: UNIX socket name too long"),path)
#line 433
)
#line 436
;
		
		addr.sa.sa_family = PF_UNIX;
		socklen = sizeof(addr.s_un);
		strcpy(addr.s_un.sun_path, path);
		
		if (stat(path, &st)) {
			(
#line 443
	env_throw_bi(env, mfe_failure, NULL, _("%s: cannot stat socket: %s"),path,strerror(errno))
#line 443
);
#line 446
		} else {
			/* FIXME: Check permissions? */
				if (!(S_ISSOCK(st.st_mode)))
#line 448
		(
#line 448
	env_throw_bi(env, mfe_failure, NULL, _("%s: not a socket"),path)
#line 448
)
#line 451
;
		}

	} else if (strcmp(proto, "inet") == 0) {
		short pnum;
		long num;
		char *p;
		
		addr.sa.sa_family = PF_INET;
		socklen = sizeof(addr.s_in);

			if (!(port != NULL))
#line 462
		(
#line 462
	env_throw_bi(env, mfe_failure, NULL, _("invalid connection type: %s; "
			    "missing port number"),cstr)
#line 462
)
#line 466
;

		num = pnum = strtol(port, &p, 0);
		if (*p == 0) {
				if (!(num == pnum))
#line 470
		(
#line 470
	env_throw_bi(env, mfe_range, NULL, _("invalid connection type: "
				    "%s; bad port number"),cstr)
#line 470
)
#line 474
;
			pnum = htons(pnum);
		} else {
			struct servent *sp = getservbyname(port, "tcp");

				if (!(sp != NULL))
#line 479
		(
#line 479
	env_throw_bi(env, mfe_failure, NULL, _("invalid connection type: "
				    "%s; unknown port name"),cstr)
#line 479
)
#line 483
;
			pnum = sp->s_port;
		}
		
		if (!path)
			addr.s_in.sin_addr.s_addr = INADDR_ANY;
		else {
			struct hostent *hp = gethostbyname(path);
				if (!(hp != NULL))
#line 491
		(
#line 491
	env_throw_bi(env, mfe_failure, NULL, _("unknown host name %s"),path)
#line 491
)
#line 494
;
			addr.sa.sa_family = hp->h_addrtype;
			switch (hp->h_addrtype) {
			case AF_INET:
				memmove(&addr.s_in.sin_addr, hp->h_addr, 4);
				addr.s_in.sin_port = pnum;
				break;

			default:
				(
#line 503
	env_throw_bi(env, mfe_range, NULL, _("invalid connection type: "
					   "%s; unsupported address family"),cstr)
#line 503
);
#line 507
			}
		}
#ifdef GACOPYZ_IPV6
	} else if (strcmp(proto, "inet6") == 0) {
		struct addrinfo hints;
		struct addrinfo *res;
		
			if (!(port != NULL))
#line 514
		(
#line 514
	env_throw_bi(env, mfe_failure, NULL, _("invalid connection type: %s; "
			    "missing port number"),cstr)
#line 514
)
#line 518
;

		memset(&hints, 0, sizeof(hints));
		hints.ai_family = AF_INET6;
		hints.ai_socktype = SOCK_STREAM;
		if (!path)
			hints.ai_flags |= AI_PASSIVE;
		
		rc = getaddrinfo(path, port, &hints, &res);
				
		switch (rc) {
		case 0:
			break;
			
		case EAI_SYSTEM:
			(
#line 533
	env_throw_bi(env, mfe_failure, NULL, _("%s:%s: cannot parse address: %s"),path,port,strerror(errno))
#line 533
);
#line 536
			
		case EAI_BADFLAGS:
		case EAI_SOCKTYPE:
			(
#line 539
	env_throw_bi(env, mfe_failure, NULL, _("%s:%d: internal error converting %s:%s"),__FILE__,__LINE__,path,port)
#line 539
);
#line 542
			
		case EAI_MEMORY:
			xalloc_die();
			
		default:
			(
#line 547
	env_throw_bi(env, mfe_failure, NULL, "%s:%s: %s",path,port,gai_strerror(rc))
#line 547
);
#line 550
		}

		socklen = res->ai_addrlen;
		if (socklen > sizeof(addr)) {
			freeaddrinfo(res);
			(
#line 555
	env_throw_bi(env, mfe_failure, NULL, _("%s:%s: address length too big (%lu)"),path,port,(unsigned long) socklen)
#line 555
);
#line 559
		}
		memcpy(&addr, res->ai_addr, res->ai_addrlen);
		freeaddrinfo(res);
#endif
	} else {
		(
#line 564
	env_throw_bi(env, mfe_range, NULL, _("unsupported protocol: %s"),proto)
#line 564
);
#line 567
	}

	fd = socket(addr.sa.sa_family, SOCK_STREAM, 0);
		if (!(fd != -1))
#line 570
		(
#line 570
	env_throw_bi(env, mfe_failure, NULL, _("unable to create new socket: %s"),strerror(errno))
#line 570
)
#line 573
;

	/* FIXME: Bind to the source ? */

	rc = connect(fd, &addr.sa, socklen);
	if (rc) {
		close(fd);
		(
#line 580
	env_throw_bi(env, mfe_failure, NULL, _("cannot connect to %s: %s"),cstr,strerror(errno))
#line 580
);
#line 583
	}
	
	str->fd[0] = fd;
	return 0;
}

static int
shutdown_inet_stream(struct io_stream *str, int how)
{
	switch (how) {
	case 0:
		how = SHUT_RD;
		break;

	case 1:
		how = SHUT_WR;
		break;

	case 2:
		how = SHUT_RDWR;
		break;

	default:
		return EINVAL;
	}
	if (shutdown(str->fd[0], how))
		return errno;
	return 0;
}

static int
open_inet_stream(eval_environ_t env,
		 struct io_stream *str, const char *addr, int flags)
{
	int rc;
	char *proto, *port, *path;

	if (gacopyz_parse_connection(addr, &proto, &port, &path)
	    != MI_SUCCESS) 
		rc = ENOMEM; /* FIXME: or EINVAL? */
	else {
		rc = open_parsed_inet_stream(env,
					     str, addr,
					     proto, port, path, flags);
		str->shutdown = shutdown_inet_stream;
		free(proto);
		free(port);
		free(path);
	}
	return rc;
}


static void *
alloc_streams()
{
	struct io_stream *p, *stab = xcalloc(nstreams, sizeof *stab);
	for (p = stab; p < stab + nstreams; p++) 
		p->fd[0] = p->fd[1] = -1;
	return stab;
}

static void
destroy_streams(void *data)
{
	struct io_stream *stab = data;
	struct io_stream *p;
	for (p = stab; p < stab + nstreams; p++) {
		close_stream(p);
		free(p->buf);
	}
	free(stab);
}
		

#line 657

#line 657
static int IO_id;
#line 657 "io.bi"


int
_bi_io_fd(eval_environ_t env, int fd, int what)
{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	int descr;

		if (!(fd >= 0 && fd < nstreams && what>=0 && what<=1))
#line 665
		(
#line 665
	env_throw_bi(env, mfe_range, NULL, _("invalid file descriptor"))
#line 665
)
#line 667
;
	descr = what == 0 ? IFD(iotab[fd]) : OFD(iotab[fd]);
		if (!(descr >= 0))
#line 669
		(
#line 669
	env_throw_bi(env, mfe_range, NULL, _("invalid file descriptor"))
#line 669
)
#line 671
;
	return descr;
}


void
#line 676
bi_open(eval_environ_t env)
#line 676

#line 676

#line 676 "io.bi"
{
#line 676
	
#line 676

#line 676

#line 676
char *  name;
#line 676
        
#line 676
get_string_arg(env, 0, &name);
#line 676
        
#line 676

#line 676
        adjust_stack(env, 1);
#line 676

#line 676

#line 676
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 676
		prog_trace(env, "open %s",name);;
#line 676

{
	int i, rc;
	int flags = 0;
	int (*opf)(eval_environ_t env,
		   struct io_stream *, const char *, int) = open_file_stream;
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	
	for (i = 0; i < nstreams; i++) {
		if (iotab[i].fd[0] == -1) 
			break;
	}
		if (!(i < nstreams))
#line 688
		(
#line 688
	env_throw_bi(env, mfe_failure, "open", _("no more files available"))
#line 688
)
#line 690
;

	
#line 692

#line 692
mu_debug(debug_handle, 10,("opening stream %s", name));
	iotab[i].name = xstrdup(name);
	iotab[i].delim = NULL;
	if (*name == '>') {
		flags |= O_RDWR|O_CREAT;
		name++;
		if (*name == '>') {
			flags |= O_APPEND;
			name++;
		} else
			flags |= O_TRUNC;
	} else if (*name == '|') {
		opf = open_program_stream;
		flags = O_WRONLY;
		name++;
		if (*name == '&') {
			flags = O_RDWR;
			name++;
		}
	} else if (*name == '@') {
		name++;
		opf = open_inet_stream;
		flags = O_RDWR;
	} else
		flags = O_RDONLY;
	
	for (;*name && c_isspace(*name); name++)
		;
	
	rc = opf(env, &iotab[i], name, flags);
	
		if (!(rc == 0))
#line 723
		(
#line 723
	env_throw_bi(env, mfe_failure, "open", _("cannot open stream %s: %s"),name,mu_strerror(rc))
#line 723
)
#line 726
;
	
#line 727

#line 727
mu_debug(debug_handle, 10,("open(%s) = %d", name, i));
	
#line 728
do {
#line 728
  push(env, (STKVAL) (i));
#line 728
  goto endlab;
#line 728
} while (0);
}
endlab:
#line 730
        env_function_cleanup_flush(env, NULL);
#line 730
	return;
#line 730
}


void
#line 733
bi_tempfile(eval_environ_t env)
#line 733

#line 733

#line 733 "io.bi"
{
#line 733
	
#line 733

#line 733
long __bi_argcnt;
#line 733
char * MFL_DATASEG tempdir;
#line 733
        
#line 733
get_string_arg(env, 1, &tempdir);
#line 733
        
#line 733
get_numeric_arg(env, 0, &__bi_argcnt);
#line 733
        adjust_stack(env, __bi_argcnt + 1);
#line 733

#line 733

#line 733
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 733
		prog_trace(env, "tempfile %s",((__bi_argcnt > 0) ? tempdir : ""));;
#line 733

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	int i;
	char *dir = ((__bi_argcnt > 0) ? tempdir : "/tmp");
	size_t dirlen = strlen(dir);
	mode_t u;
	int fd;
	char *template;
#define PATTERN "mfdXXXXXX"

	for (i = 0; i < nstreams; i++) {
		if (iotab[i].fd[0] == -1) 
			break;
	}
		if (!(i < nstreams))
#line 748
		(
#line 748
	env_throw_bi(env, mfe_failure, "tempfile", _("no more files available"))
#line 748
)
#line 750
;


	while (dirlen > 0 && dir[dirlen-1] == '/')
		dirlen--;

	template = heap_tempspace(env, (dirlen ? dirlen + 1 : 0) +
#line 756
				      sizeof(PATTERN));
#line 758
	if (dirlen) {
		memcpy(template, dir, dirlen);
		template[dirlen++] = '/';
	}
	strcpy(template + dirlen, PATTERN);
	u = umask(077);
	fd = mkstemp(template);
	umask(u);
		if (!(fd >= 0))
#line 766
		(
#line 766
	env_throw_bi(env, mfe_failure, "tempfile", "mkstemp failed: %s",mu_strerror(errno))
#line 766
)
#line 769
;
	unlink(template);

	iotab[i].fd[0] = fd;
	
	
#line 774
do {
#line 774
  push(env, (STKVAL) (i));
#line 774
  goto endlab;
#line 774
} while (0);
#undef PATTERN
}
endlab:
#line 777
        env_function_cleanup_flush(env, NULL);
#line 777
	return;
#line 777
}

void
#line 779
bi_close(eval_environ_t env)
#line 779

#line 779

#line 779 "io.bi"
{
#line 779
	
#line 779

#line 779

#line 779
long  fd;
#line 779
        
#line 779
get_numeric_arg(env, 0, &fd);
#line 779
        
#line 779

#line 779
        adjust_stack(env, 1);
#line 779

#line 779

#line 779
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 779
		prog_trace(env, "close %lu",fd);;
#line 779

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);

		if (!(fd >= 0 && fd < nstreams))
#line 783
		(
#line 783
	env_throw_bi(env, mfe_range, "close", _("invalid file descriptor"))
#line 783
)
#line 785
;
	close_stream(&iotab[fd]);
}

#line 788
        env_function_cleanup_flush(env, NULL);
#line 788
	return;
#line 788
}	

static struct builtin_const_trans shutdown_modes[] = {
	{ _MFL_SHUT_RD, SHUT_RD },
	{ _MFL_SHUT_WR, SHUT_WR },
	{ _MFL_SHUT_RDWR, SHUT_RDWR }
};

void
#line 796
bi_shutdown(eval_environ_t env)
#line 796

#line 796

#line 796 "io.bi"
{
#line 796
	
#line 796

#line 796

#line 796
long  fd;
#line 796
        long  how;
#line 796
        
#line 796
get_numeric_arg(env, 0, &fd);
#line 796
        get_numeric_arg(env, 1, &how);
#line 796
        
#line 796

#line 796
        adjust_stack(env, 2);
#line 796

#line 796

#line 796
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 796
		prog_trace(env, "shutdown %lu %lu",fd, how);;
#line 796

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	struct io_stream *ioptr;
	int mode;
	
		if (!(fd >= 0 && fd < nstreams))
#line 802
		(
#line 802
	env_throw_bi(env, mfe_range, "shutdown", _("invalid file descriptor"))
#line 802
)
#line 804
;
		if (!(how >= 0 && how <= 2))
#line 805
		(
#line 805
	env_throw_bi(env, mfe_range, "shutdown", _("invalid file descriptor"))
#line 805
)
#line 807
;
		if (!(_builtin_const_to_c(shutdown_modes,
#line 808
				      MU_ARRAY_SIZE(shutdown_modes),
#line 808
				      how,
#line 808
				      &mode) == 0))
#line 808
		(
#line 808
	env_throw_bi(env, mfe_failure, "shutdown", "bad shutdown mode")
#line 808
)
#line 813
;
	
	ioptr = &iotab[fd];
	if (ioptr->shutdown) {
		int rc = ioptr->shutdown(ioptr, mode);
			if (!(rc == 0))
#line 818
		(
#line 818
	env_throw_bi(env, mfe_io, "shutdown", "shutdown failed: %s",mu_strerror(rc))
#line 818
)
#line 821
;
	} else if (how == 2)
		close_stream(ioptr);
	else if (ioptr->fd[how]) {
		close(ioptr->fd[how]);
		ioptr->fd[how] = -1;
	}
}

#line 829
        env_function_cleanup_flush(env, NULL);
#line 829
	return;
#line 829
}

void
#line 831
bi_write(eval_environ_t env)
#line 831

#line 831

#line 831 "io.bi"
{
#line 831
	
#line 831

#line 831
long __bi_argcnt;
#line 831
long  fd;
#line 831
        char *  str;
#line 831
        long  n;
#line 831
        
#line 831
get_numeric_arg(env, 1, &fd);
#line 831
        get_string_arg(env, 2, &str);
#line 831
        get_numeric_arg(env, 3, &n);
#line 831
        
#line 831
get_numeric_arg(env, 0, &__bi_argcnt);
#line 831
        adjust_stack(env, __bi_argcnt + 1);
#line 831

#line 831

#line 831
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 831
		prog_trace(env, "write %lu %s %lu",fd, str, ((__bi_argcnt > 2) ? n : 0));;
#line 831

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	int rc;
	
	
#line 836

#line 836
mu_debug(debug_handle, 10,("writing %s to %lu", str, fd));
		if (!(fd >= 0 && fd < nstreams && OFD(iotab[fd]) != -1))
#line 837
		(
#line 837
	env_throw_bi(env, mfe_range, "write", _("invalid file descriptor"))
#line 837
)
#line 839
;
	if (!(__bi_argcnt > 2))
		n = strlen (str);
	rc = write(OFD(iotab[fd]), str, n);
		if (!(n == rc))
#line 843
		(
#line 843
	env_throw_bi(env, mfe_io, "write", _("write error on %s: %s"),iotab[fd].name,mu_strerror(errno))
#line 843
)
#line 846
;
}

#line 848
        env_function_cleanup_flush(env, NULL);
#line 848
	return;
#line 848
}

void
#line 850
bi_read(eval_environ_t env)
#line 850

#line 850

#line 850 "io.bi"
{
#line 850
	
#line 850

#line 850

#line 850
long  fd;
#line 850
        long  size;
#line 850
        
#line 850
get_numeric_arg(env, 0, &fd);
#line 850
        get_numeric_arg(env, 1, &size);
#line 850
        
#line 850

#line 850
        adjust_stack(env, 2);
#line 850

#line 850

#line 850
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 850
		prog_trace(env, "read %lu %lu",fd, size);;
#line 850

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	int rc;
	size_t off;
	char *s = (char*) env_data_ref(env, (off = heap_reserve(env, size + 1)));

		if (!(fd >= 0 && fd < nstreams && IFD(iotab[fd]) != -1))
#line 857
		(
#line 857
	env_throw_bi(env, mfe_range, "read", _("invalid file descriptor"))
#line 857
)
#line 859
;
	
	rc = read(IFD(iotab[fd]), s, size);
	if (rc == 0)
		(
#line 863
	env_throw_bi(env, mfe_eof, "read", _("EOF on %s"),iotab[fd].name)
#line 863
);
#line 865
		if (!(rc == size))
#line 865
		(
#line 865
	env_throw_bi(env, mfe_io, "read", _("read error on %s: %s"),iotab[fd].name,mu_strerror(errno))
#line 865
)
#line 868
;
	s[size] = 0;
	
#line 870
do {
#line 870
  push(env, (STKVAL) (off));
#line 870
  goto endlab;
#line 870
} while (0);
}	
endlab:
#line 872
        env_function_cleanup_flush(env, NULL);
#line 872
	return;
#line 872
}

void
#line 874
bi_rewind(eval_environ_t env)
#line 874

#line 874

#line 874 "io.bi"
{
#line 874
	
#line 874

#line 874

#line 874
long  fd;
#line 874
        
#line 874
get_numeric_arg(env, 0, &fd);
#line 874
        
#line 874

#line 874
        adjust_stack(env, 1);
#line 874

#line 874

#line 874
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 874
		prog_trace(env, "rewind %lu",fd);;
#line 874

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);

		if (!(fd >= 0 && fd < nstreams && IFD(iotab[fd]) != -1))
#line 878
		(
#line 878
	env_throw_bi(env, mfe_range, "rewind", _("invalid file descriptor"))
#line 878
)
#line 880
;
	if (lseek(IFD(iotab[fd]), 0, SEEK_SET) == -1)
		(
#line 882
	env_throw_bi(env, mfe_io, "rewind", "seek failed: %s",mu_strerror(errno))
#line 882
);
#line 885
}

#line 886
        env_function_cleanup_flush(env, NULL);
#line 886
	return;
#line 886
}
	

#define MINBUFSIZE 128
#define MAXBUFSIZE 65535

void
#line 892
bi_copy(eval_environ_t env)
#line 892

#line 892

#line 892 "io.bi"
{
#line 892
	
#line 892

#line 892

#line 892
long  dst;
#line 892
        long  src;
#line 892
        
#line 892
get_numeric_arg(env, 0, &dst);
#line 892
        get_numeric_arg(env, 1, &src);
#line 892
        
#line 892

#line 892
        adjust_stack(env, 2);
#line 892

#line 892

#line 892
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 892
		prog_trace(env, "copy %lu %lu",dst, src);;
#line 892

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	int ifd, ofd;
	char *buffer;
	size_t bufsize = MAXBUFSIZE;
	char bs[MINBUFSIZE];
	off_t cur, end;
	size_t total = 0;
	ssize_t rdbytes;
	
		if (!(src >= 0 && src < nstreams && (ifd = IFD(iotab[src])) != -1))
#line 903
		(
#line 903
	env_throw_bi(env, mfe_range, "copy", _("invalid source file descriptor"))
#line 903
)
#line 905
;
		if (!(dst >= 0 && dst < nstreams && (ofd = OFD(iotab[dst])) != -1))
#line 906
		(
#line 906
	env_throw_bi(env, mfe_range, "copy", _("invalid destination file descriptor"))
#line 906
)
#line 908
;

	cur = lseek (ifd, 0, SEEK_CUR);
	if (cur != -1) {
		end = lseek (ifd, 0, SEEK_END);
		if (end != -1) {
			if (end < MAXBUFSIZE)
				bufsize = end;
			lseek (ifd, cur, SEEK_SET);
		}
	}

	for (; (buffer = malloc (bufsize)) == NULL; bufsize >>= 1)
		if (bufsize < MINBUFSIZE) {
			buffer = bs;
			bufsize = MINBUFSIZE;
			break;
		}

	while ((rdbytes = read(ifd, buffer, bufsize)) > 0) {
		char *p = buffer;
		while (rdbytes) {
			ssize_t wrbytes = write(ofd, p, rdbytes);
			if (wrbytes == -1) {
				if (buffer != bs)
					free(buffer);
				(
#line 934
	env_throw_bi(env, mfe_io, "copy", "write error: %s",mu_strerror(errno))
#line 934
);
#line 937
			} else if (wrbytes == 0) {
				if (buffer != bs)
					free(buffer);
				(
#line 940
	env_throw_bi(env, mfe_io, "copy", "short write")
#line 940
);
#line 942
			}
			p += wrbytes;
			rdbytes -= wrbytes;
			total += wrbytes;
		}
	}
	if (buffer != bs)
		free(buffer);
	
#line 950
do {
#line 950
  push(env, (STKVAL) (total));
#line 950
  goto endlab;
#line 950
} while (0);
}
endlab:
#line 952
        env_function_cleanup_flush(env, NULL);
#line 952
	return;
#line 952
}

void
#line 954
bi_getdelim(eval_environ_t env)
#line 954

#line 954

#line 954 "io.bi"
{
#line 954
	
#line 954

#line 954

#line 954
long  fd;
#line 954
        char * MFL_DATASEG delim;
#line 954
        
#line 954
get_numeric_arg(env, 0, &fd);
#line 954
        get_string_arg(env, 1, &delim);
#line 954
        
#line 954

#line 954
        adjust_stack(env, 2);
#line 954

#line 954

#line 954
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 954
		prog_trace(env, "getdelim %lu %s",fd, delim);;
#line 954

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	struct io_stream *ioptr;
	int rc;
	
		if (!(fd >= 0 && fd < nstreams && IFD(iotab[fd]) != -1))
#line 960
		(
#line 960
	env_throw_bi(env, mfe_range, "getdelim", _("invalid file descriptor"))
#line 960
)
#line 962
;
	ioptr = &iotab[fd];
	rc = read_stream_delim(ioptr, delim); 
	if (rc == 0)
		(
#line 966
	env_throw_bi(env, mfe_eof, "getdelim", _("EOF on %s"),ioptr->name)
#line 966
);
		if (!(rc > 0))
#line 967
		(
#line 967
	env_throw_bi(env, mfe_io, "getdelim", _("read error on %s: %s"),ioptr->name,mu_strerror(errno))
#line 967
)
#line 970
;
	do {pushs(env, ioptr->buf);
#line 971
goto endlab;
#line 971
} while (0);
}	
endlab:
#line 973
        env_function_cleanup_flush(env, NULL);
#line 973
	return;
#line 973
}

void
#line 975
bi_getline(eval_environ_t env)
#line 975

#line 975

#line 975 "io.bi"
{
#line 975
	
#line 975

#line 975

#line 975
long  fd;
#line 975
        
#line 975
get_numeric_arg(env, 0, &fd);
#line 975
        
#line 975

#line 975
        adjust_stack(env, 1);
#line 975

#line 975

#line 975
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 975
		prog_trace(env, "getline %lu",fd);;
#line 975

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	struct io_stream *ioptr;
	int rc;

		if (!(fd >= 0 && fd < nstreams && IFD(iotab[fd]) != -1))
#line 981
		(
#line 981
	env_throw_bi(env, mfe_range, "getline", _("invalid file descriptor"))
#line 981
)
#line 983
;
	ioptr = &iotab[fd];
	rc = read_stream_delim(ioptr, ioptr->delim ? ioptr->delim : "\n");
	if (rc == 0)
		(
#line 987
	env_throw_bi(env, mfe_eof, "getline", _("EOF on %s"),ioptr->name)
#line 987
);
#line 989
		if (!(rc > 0))
#line 989
		(
#line 989
	env_throw_bi(env, mfe_io, "getline", _("read error on %s: %s"),ioptr->name,mu_strerror(errno))
#line 989
)
#line 992
;
	do {pushs(env, ioptr->buf);
#line 993
goto endlab;
#line 993
} while (0);
}	
endlab:
#line 995
        env_function_cleanup_flush(env, NULL);
#line 995
	return;
#line 995
}

void
#line 997
bi_fd_set_delimiter(eval_environ_t env)
#line 997

#line 997

#line 997 "io.bi"
{
#line 997
	
#line 997

#line 997

#line 997
long  fd;
#line 997
        char *  delim;
#line 997
        
#line 997
get_numeric_arg(env, 0, &fd);
#line 997
        get_string_arg(env, 1, &delim);
#line 997
        
#line 997

#line 997
        adjust_stack(env, 2);
#line 997

#line 997

#line 997
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 997
		prog_trace(env, "fd_set_delimiter %lu %s",fd, delim);;
#line 997

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	struct io_stream *ioptr;

		if (!(fd >= 0 && fd < nstreams && IFD(iotab[fd]) != -1))
#line 1002
		(
#line 1002
	env_throw_bi(env, mfe_range, "fd_set_delimiter", _("invalid file descriptor"))
#line 1002
)
#line 1004
;
	ioptr = &iotab[fd];
	free(ioptr->delim);
	ioptr->delim = xstrdup(delim);
}

#line 1009
        env_function_cleanup_flush(env, NULL);
#line 1009
	return;
#line 1009
}

void
#line 1011
bi_fd_delimiter(eval_environ_t env)
#line 1011

#line 1011

#line 1011 "io.bi"
{
#line 1011
	
#line 1011

#line 1011

#line 1011
long  fd;
#line 1011
        char * MFL_DATASEG delim;
#line 1011
        
#line 1011
get_numeric_arg(env, 0, &fd);
#line 1011
        get_string_arg(env, 1, &delim);
#line 1011
        
#line 1011

#line 1011
        adjust_stack(env, 2);
#line 1011

#line 1011

#line 1011
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 1011
		prog_trace(env, "fd_delimiter %lu %s",fd, delim);;
#line 1011

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	struct io_stream *ioptr;

		if (!(fd >= 0 && fd < nstreams && IFD(iotab[fd]) != -1))
#line 1016
		(
#line 1016
	env_throw_bi(env, mfe_range, "fd_delimiter", _("invalid file descriptor"))
#line 1016
)
#line 1018
;
	ioptr = &iotab[fd];
	do {pushs(env, ioptr->delim ? ioptr->delim : "\n");
#line 1020
goto endlab;
#line 1020
} while (0);
}
endlab:
#line 1022
        env_function_cleanup_flush(env, NULL);
#line 1022
	return;
#line 1022
}


#line 1024
void
#line 1024
io_init_builtin()
#line 1024
{
#line 1024
		debug_handle = mu_debug_register_category("bi_io");
#line 1024

#line 1024
	#line 657 "io.bi"
IO_id = builtin_priv_register(alloc_streams, destroy_streams,
#line 657
NULL);
#line 676 "io.bi"
va_builtin_install_ex("open", bi_open, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 733 "io.bi"
va_builtin_install_ex("tempfile", bi_tempfile, 0, dtype_number, 1, 1, 0|0, dtype_string);
#line 779 "io.bi"
va_builtin_install_ex("close", bi_close, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 796 "io.bi"
va_builtin_install_ex("shutdown", bi_shutdown, 0, dtype_unspecified, 2, 0, 0|0, dtype_number, dtype_number);
#line 831 "io.bi"
va_builtin_install_ex("write", bi_write, 0, dtype_unspecified, 3, 1, 0|0, dtype_number, dtype_string, dtype_number);
#line 850 "io.bi"
va_builtin_install_ex("read", bi_read, 0, dtype_string, 2, 0, 0|0, dtype_number, dtype_number);
#line 874 "io.bi"
va_builtin_install_ex("rewind", bi_rewind, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 892 "io.bi"
va_builtin_install_ex("copy", bi_copy, 0, dtype_number, 2, 0, 0|0, dtype_number, dtype_number);
#line 954 "io.bi"
va_builtin_install_ex("getdelim", bi_getdelim, 0, dtype_string, 2, 0, 0|0, dtype_number, dtype_string);
#line 975 "io.bi"
va_builtin_install_ex("getline", bi_getline, 0, dtype_string, 1, 0, 0|0, dtype_number);
#line 997 "io.bi"
va_builtin_install_ex("fd_set_delimiter", bi_fd_set_delimiter, 0, dtype_unspecified, 2, 0, 0|0, dtype_number, dtype_string);
#line 1011 "io.bi"
va_builtin_install_ex("fd_delimiter", bi_fd_delimiter, 0, dtype_string, 2, 0, 0|0, dtype_number, dtype_string);

#line 1024 "io.bi"
	
#line 1024
	 mf_add_runtime_params(io_cfg_param);
#line 1024
	 
#line 1024
}
#line 1024 "io.bi"

#line 1026

#line 759 "../../src/builtin/snarf.m4"

#line 759

